package io.syndesis.integration.component.proxy;

import com.fasterxml.jackson.annotation.JsonProperty;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import org.immutables.value.Generated;

/**
 * Immutable implementation of {@link ComponentDefinition.When}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code new ImmutableWhen.Builder()}.
 */
@Generated(from = "ComponentDefinition.When", generator = "Immutables")
@SuppressWarnings({"all"})
@javax.annotation.processing.Generated("org.immutables.processor.ProxyProcessor")
public final class ImmutableWhen implements ComponentDefinition.When {
  private final String id;
  private final String value;

  private ImmutableWhen(String id, String value) {
    this.id = id;
    this.value = value;
  }

  /**
   * @return The value of the {@code id} attribute
   */
  @JsonProperty("id")
  @Override
  public String getId() {
    return id;
  }

  /**
   * @return The value of the {@code value} attribute
   */
  @JsonProperty("value")
  @Override
  public String getValue() {
    return value;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link ComponentDefinition.When#getId() id} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for id
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableWhen withId(String value) {
    String newValue = Objects.requireNonNull(value, "id");
    if (this.id.equals(newValue)) return this;
    return new ImmutableWhen(newValue, this.value);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link ComponentDefinition.When#getValue() value} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for value
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableWhen withValue(String value) {
    String newValue = Objects.requireNonNull(value, "value");
    if (this.value.equals(newValue)) return this;
    return new ImmutableWhen(this.id, newValue);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableWhen} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(Object another) {
    if (this == another) return true;
    return another instanceof ImmutableWhen
        && equalTo((ImmutableWhen) another);
  }

  private boolean equalTo(ImmutableWhen another) {
    return id.equals(another.id)
        && value.equals(another.value);
  }

  /**
   * Computes a hash code from attributes: {@code id}, {@code value}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    int h = 5381;
    h += (h << 5) + id.hashCode();
    h += (h << 5) + value.hashCode();
    return h;
  }

  /**
   * Prints the immutable value {@code When} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return "When{"
        + "id=" + id
        + ", value=" + value
        + "}";
  }

  /**
   * Creates an immutable copy of a {@link ComponentDefinition.When} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable When instance
   */
  public static ImmutableWhen copyOf(ComponentDefinition.When instance) {
    if (instance instanceof ImmutableWhen) {
      return (ImmutableWhen) instance;
    }
    return new ImmutableWhen.Builder()
        .from(instance)
        .build();
  }

  /**
   * Builds instances of type {@link ImmutableWhen ImmutableWhen}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "ComponentDefinition.When", generator = "Immutables")
  public static final class Builder {
    private static final long INIT_BIT_ID = 0x1L;
    private static final long INIT_BIT_VALUE = 0x2L;
    private long initBits = 0x3L;

    private String id;
    private String value;

    /**
     * Creates a builder for {@link ImmutableWhen ImmutableWhen} instances.
     * <pre>
     * new ImmutableWhen.Builder()
     *    .id(String) // required {@link ComponentDefinition.When#getId() id}
     *    .value(String) // required {@link ComponentDefinition.When#getValue() value}
     *    .build();
     * </pre>
     */
    public Builder() {
    }

    /**
     * Fill a builder with attribute values from the provided {@code When} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    public final Builder from(ComponentDefinition.When instance) {
      Objects.requireNonNull(instance, "instance");
      id(instance.getId());
      value(instance.getValue());
      return this;
    }

    /**
     * Initializes the value for the {@link ComponentDefinition.When#getId() id} attribute.
     * @param id The value for id 
     * @return {@code this} builder for use in a chained invocation
     */
    @JsonProperty("id")
    public final Builder id(String id) {
      this.id = Objects.requireNonNull(id, "id");
      initBits &= ~INIT_BIT_ID;
      return this;
    }

    /**
     * Initializes the value for the {@link ComponentDefinition.When#getValue() value} attribute.
     * @param value The value for value 
     * @return {@code this} builder for use in a chained invocation
     */
    @JsonProperty("value")
    public final Builder value(String value) {
      this.value = Objects.requireNonNull(value, "value");
      initBits &= ~INIT_BIT_VALUE;
      return this;
    }

    /**
     * Builds a new {@link ImmutableWhen ImmutableWhen}.
     * @return An immutable instance of When
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableWhen build() {
      if (initBits != 0) {
        throw new IllegalStateException(formatRequiredAttributesMessage());
      }
      return new ImmutableWhen(id, value);
    }

    private String formatRequiredAttributesMessage() {
      List<String> attributes = new ArrayList<>();
      if ((initBits & INIT_BIT_ID) != 0) attributes.add("id");
      if ((initBits & INIT_BIT_VALUE) != 0) attributes.add("value");
      return "Cannot build When, some of required attributes are not set " + attributes;
    }
  }
}
